/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// pile réalisée avec une liste simplement chaînée

#include "prelude.h"

#include "list.h"
#include "stack.h"

struct Stack { list *head; };

stack *stack_create(void) {
  stack *s = malloc(sizeof(struct Stack));
  s->head = NULL;
  return s;
}

bool stack_is_empty(stack *s) {
  return s->head == NULL;
}

void stack_push(stack *s, int x) {
  s->head = list_cons(x, s->head);
}

int stack_top(stack *s) {
  assert(!stack_is_empty(s));
  return s->head->value;
}

int stack_pop(stack *s) {
  assert(!stack_is_empty(s));
  int v = s->head->value;
  list *p = s->head;
  s->head = p->next;
  free(p);
  return v;
}

void stack_delete(stack *s) {
  list_delete(s->head);
  free(s);
}
